Index: LMDZ5/branches/testing/libf/phylmd/iophy.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/iophy.F90	(revision 1864)
@@ -651,5 +1056,147 @@
       ENDDO
 !$OMP END MASTER   
+  ENDIF ! vars_defined
+  IF (prt_level >= 9) write(lunout,*)'End histrwrite3d ',var%name
   END SUBROUTINE histwrite3d_phy
   
+
+! VERSION DES HISTWRITE DEDIEES AU TOUT-XIOS-XML DEJA UTILISEE DANS PHYDEV
+#ifdef CPP_XIOS
+  SUBROUTINE histwrite2d_xios(field_name,field)
+  USE dimphy
+  USE mod_phys_lmdz_para
+  USE wxios
+
+
+  IMPLICIT NONE
+  INCLUDE 'dimensions.h'
+  INCLUDE 'iniprint.h'
+
+    CHARACTER(LEN=*), INTENT(IN) :: field_name
+    REAL, DIMENSION(:), INTENT(IN) :: field
+      
+    REAL,DIMENSION(klon_mpi) :: buffer_omp
+    INTEGER, allocatable, DIMENSION(:) :: index2d
+    REAL :: Field2d(iim,jj_nb)
+
+    INTEGER :: ip
+    REAL, ALLOCATABLE, DIMENSION(:) :: fieldok
+
+    IF (prt_level >= 9) WRITE(lunout,*)'Begin histrwrite2d_xios ',field_name
+
+    !Et sinon on.... écrit
+    IF (SIZE(field)/=klon) CALL abort_gcm('iophy::histwrite2d_xios','Field first DIMENSION not equal to klon',1)
+    
+    CALL Gather_omp(field,buffer_omp)    
+!$OMP MASTER
+    CALL grid1Dto2D_mpi(buffer_omp,Field2d)
+    
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!ATTENTION, STATIONS PAS GEREES !
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !IF(.NOT.clef_stations(iff)) THEN
+    IF (.TRUE.) THEN
+        ALLOCATE(index2d(iim*jj_nb))
+        ALLOCATE(fieldok(iim*jj_nb))
+
+
+        CALL wxios_write_2D(field_name, Field2d)
+
+    ELSE 
+        ALLOCATE(fieldok(npstn))
+        ALLOCATE(index2d(npstn))
+
+        IF (is_sequential) THEN
+            DO ip=1, npstn
+                fieldok(ip)=buffer_omp(nptabij(ip))
+            ENDDO
+        ELSE
+            DO ip=1, npstn
+                PRINT*,'histwrite2d_xios is_sequential npstn ip namenptabij',npstn,ip,field_name,nptabij(ip)
+                IF(nptabij(ip).GE.klon_mpi_begin.AND. &
+                nptabij(ip).LE.klon_mpi_end) THEN
+                    fieldok(ip)=buffer_omp(nptabij(ip)-klon_mpi_begin+1)
+                ENDIF
+            ENDDO
+        ENDIF
+
+    ENDIF
+                  
+    deallocate(index2d)
+    deallocate(fieldok)
+!$OMP END MASTER   
+
+  IF (prt_level >= 9) WRITE(lunout,*)'End histrwrite2d_xios ',field_name
+  END SUBROUTINE histwrite2d_xios
+
+
+! ug NOUVELLE VERSION DES WRITE AVEC LA BOUCLE DO RENTREE
+  SUBROUTINE histwrite3d_xios(field_name, field)
+  USE dimphy
+  USE mod_phys_lmdz_para
+  USE wxios
+
+
+  IMPLICIT NONE
+  INCLUDE 'dimensions.h'
+  INCLUDE 'iniprint.h'
+
+    CHARACTER(LEN=*), INTENT(IN) :: field_name
+    REAL, DIMENSION(:,:), INTENT(IN) :: field ! --> field(klon,:)
+
+    REAL,DIMENSION(klon_mpi,SIZE(field,2)) :: buffer_omp
+    REAL :: Field3d(iim,jj_nb,SIZE(field,2))
+    INTEGER :: ip, n, nlev
+    INTEGER, ALLOCATABLE, DIMENSION(:) :: index3d
+    REAL,ALLOCATABLE, DIMENSION(:,:) :: fieldok
+
+  IF (prt_level >= 9) write(lunout,*)'Begin histrwrite3d_xios ',field_name
+
+    !Et on.... écrit
+    IF (SIZE(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first DIMENSION not equal to klon',1)
+    nlev=SIZE(field,2)
+
+
+    CALL Gather_omp(field,buffer_omp)
+!$OMP MASTER
+    CALL grid1Dto2D_mpi(buffer_omp,field3d)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!ATTENTION, STATIONS PAS GEREES !
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    !IF (.NOT.clef_stations(iff)) THEN
+    IF(.TRUE.)THEN
+        ALLOCATE(index3d(iim*jj_nb*nlev))
+        ALLOCATE(fieldok(iim*jj_nb,nlev))
+        CALL wxios_write_3D(field_name, Field3d(:,:,1:klev))
+                        
+    ELSE 
+        nlev=size(field,2)
+        ALLOCATE(index3d(npstn*nlev))
+        ALLOCATE(fieldok(npstn,nlev))
+
+        IF (is_sequential) THEN
+            DO n=1, nlev
+                DO ip=1, npstn
+                    fieldok(ip,n)=buffer_omp(nptabij(ip),n)
+                ENDDO
+            ENDDO
+        ELSE
+            DO n=1, nlev
+                DO ip=1, npstn
+                    IF(nptabij(ip).GE.klon_mpi_begin.AND. &
+                    nptabij(ip).LE.klon_mpi_end) THEN
+                        fieldok(ip,n)=buffer_omp(nptabij(ip)-klon_mpi_begin+1,n)
+                    ENDIF
+                ENDDO
+            ENDDO
+        ENDIF
+    ENDIF 
+    deallocate(index3d)
+    deallocate(fieldok)
+!$OMP END MASTER   
+
+  IF (prt_level >= 9) write(lunout,*)'End histrwrite3d_xios ',field_name
+  END SUBROUTINE histwrite3d_xios
+#endif
 end module iophy
Index: LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 1864)
@@ -174,5 +174,5 @@
        t,         q,         u,        v,             &
        pplay,     paprs,     pctsrf,                  &
-       ts,        alb1,      alb2,ustar, u10m, v10m,  &
+       ts,        alb1, alb2,ustar, u10m, v10m,wstar, &
        lwdown_m,  cdragh,    cdragm,   zu1,    zv1,   &
        alb1_m,    alb2_m,    zxsens,   zxevap,        &
@@ -294,4 +294,5 @@
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: alb2    ! albedo in near infra-red SW interval
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: ustar   ! u* (m/s)
+    REAL, DIMENSION(klon, nbsrf+1), INTENT(INOUT)   :: wstar   ! w* (m/s)
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: u10m    ! u speed at 10m
     REAL, DIMENSION(klon, nbsrf), INTENT(INOUT)     :: v10m    ! v speed at 10m
@@ -406,4 +407,5 @@
     REAL, DIMENSION(klon)              :: yt2m, yq2m, yu10m
     REAL, DIMENSION(klon)              :: yustar
+    REAL, DIMENSION(klon)              :: ywstar
     REAL, DIMENSION(klon)              :: ywindsp
     REAL, DIMENSION(klon)              :: yt10m, yq10m
@@ -1065,4 +1067,5 @@
        q2m(:,nsrf)    = 0.
        ustar(:,nsrf)   = 0.
+       wstar(:,nsrf)   = 0.
        u10m(:,nsrf)   = 0.
        v10m(:,nsrf)   = 0.
@@ -1145,6 +1148,6 @@
 
 !   print*,'OK pbl 5'
-       CALL HBTM(knon, ypaprs, ypplay, &
-            yt2m,yt10m,yq2m,yq10m,yustar, &
+       CALL hbtm(knon, ypaprs, ypplay, &
+            yt2m,yt10m,yq2m,yq10m,yustar,ywstar, &
             y_flux_t,y_flux_q,yu,yv,yt,yq, &
             ypblh,ycapCL,yoliqCL,ycteiCL,ypblT, &
@@ -1154,4 +1157,5 @@
           i = ni(j)
           pblh(i,nsrf)   = ypblh(j)
+          wstar(i,nsrf)  = ywstar(j)
           plcl(i,nsrf)   = ylcl(j)
           capCL(i,nsrf)  = ycapCL(j)
@@ -1215,4 +1219,5 @@
     s_therm(:) = 0.0 ; s_trmb1(:) = 0.0
     s_trmb2(:) = 0.0 ; s_trmb3(:) = 0.0
+    wstar(:,is_ave)=0.
     
 !   print*,'OK pbl 9'
@@ -1233,4 +1238,5 @@
           zq2m(i)  = zq2m(i)  + q2m(i,nsrf)  * pctsrf(i,nsrf)
           zustar(i) = zustar(i) + ustar(i,nsrf) * pctsrf(i,nsrf)
+          wstar(i,is_ave)=wstar(i,is_ave)+wstar(i,nsrf)*pctsrf(i,nsrf)
           zu10m(i) = zu10m(i) + u10m(i,nsrf) * pctsrf(i,nsrf)
           zv10m(i) = zv10m(i) + v10m(i,nsrf) * pctsrf(i,nsrf)
